package com.zhongzheng.modules.course.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.common.utils.ServletUtils;
import com.zhongzheng.modules.course.bo.TeacherProjectAddBo;
import com.zhongzheng.modules.course.domain.TeacherProject;
import com.zhongzheng.modules.course.service.ITeacherProjectService;
import com.zhongzheng.modules.course.vo.TeacherProjectVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.course.bo.TeacherAddBo;
import com.zhongzheng.modules.course.bo.TeacherQueryBo;
import com.zhongzheng.modules.course.bo.TeacherEditBo;
import com.zhongzheng.modules.course.domain.Teacher;
import com.zhongzheng.modules.course.mapper.TeacherMapper;
import com.zhongzheng.modules.course.vo.TeacherVo;
import com.zhongzheng.modules.course.service.ITeacherService;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 名师Service业务层处理
 *
 * @author ruoyi
 * @date 2021-11-29
 */
@Service
public class TeacherServiceImpl extends ServiceImpl<TeacherMapper, Teacher> implements ITeacherService {

    @Autowired
    private ITeacherProjectService teacherProjectService;

    @Override
    public TeacherVo queryById(Long teacherId){
        Teacher db = this.baseMapper.selectById(teacherId);
        TeacherVo teacherVo = BeanUtil.toBean(db, TeacherVo.class);
        List<TeacherProjectVo> teacherProjectVo = teacherProjectService.queryTeacher(teacherVo.getTeacherId());
        //要转换的list集合
        List<Long> testList = new ArrayList();
        for (TeacherProjectVo projectVo : teacherProjectVo) {
            testList.add(projectVo.getProjectId());
        }

        //初始化需要得到的数组
        Long[] array = new Long[testList.size()];

        //使用for循环得到数组
        for(int i = 0; i < testList.size();i++){
            array[i] = testList.get(i);
        }
        teacherVo.setTeacherProjects(array);
        return teacherVo;
    }

    @Override
    public List<TeacherVo> queryList(TeacherQueryBo bo) {
        LambdaQueryWrapper<Teacher> lqw = Wrappers.lambdaQuery();
        lqw.like(StrUtil.isNotBlank(bo.getTeacherName()), Teacher::getTeacherName, bo.getTeacherName());
        lqw.eq(StrUtil.isNotBlank(bo.getIntroduce()), Teacher::getIntroduce, bo.getIntroduce());
        lqw.eq(StrUtil.isNotBlank(bo.getAvatar()), Teacher::getAvatar, bo.getAvatar());
        lqw.in(bo.getStatus() != null, Teacher::getStatus, bo.getStatus());
        lqw.eq(StrUtil.isNotBlank(bo.getEncoder()), Teacher::getEncoder, bo.getEncoder());
        lqw.eq(bo.getSex() != null, Teacher::getSex, bo.getSex());
        lqw.eq(bo.getOldYear() != null, Teacher::getOldYear, bo.getOldYear());
        List<TeacherVo> teacherVos = entity2Vo(this.list(lqw));
        for (TeacherVo teacherVo : teacherVos) {
            List<TeacherProjectVo> teacherProjectVo = teacherProjectService.queryTeacher(teacherVo.getTeacherId());

            teacherVo.setTeacherProjectList(teacherProjectVo);
        }
        return teacherVos;
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<TeacherVo> entity2Vo(Collection<Teacher> collection) {
        List<TeacherVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, TeacherVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<Teacher> page = (Page<Teacher>)collection;
            Page<TeacherVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(TeacherAddBo bo) {
        Teacher add = BeanUtil.toBean(bo, Teacher.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        add.setEncoder(ServletUtils.getEncoded("MK"));
        boolean save = this.save(add);
        for (Long id : bo.getTeacherProjects()) {
            TeacherProjectAddBo teacherProjectAddBo = new TeacherProjectAddBo();
            teacherProjectAddBo.setTeacherId(add.getTeacherId());
            teacherProjectAddBo.setProjectId(id);
            teacherProjectAddBo.setCreateTime(DateUtils.getNowTime());
            teacherProjectAddBo.setUpdateTime(DateUtils.getNowTime());
            teacherProjectService.insertByAddBo(teacherProjectAddBo);
        }
        return save;
    }

    @Override
    public Boolean updateByEditBo(TeacherEditBo bo) {
        Teacher update = BeanUtil.toBean(bo, Teacher.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        if (bo.getTeacherProjects() != null) {
            LambdaQueryWrapper<TeacherProject> lqw = Wrappers.lambdaQuery();
            lqw.eq(TeacherProject::getTeacherId, update.getTeacherId());
            teacherProjectService.remove(lqw);
            for (Long id : bo.getTeacherProjects()) {
                TeacherProjectAddBo teacherProjectAddBo = new TeacherProjectAddBo();
                teacherProjectAddBo.setTeacherId(update.getTeacherId());
                teacherProjectAddBo.setProjectId(id);
                teacherProjectAddBo.setCreateTime(DateUtils.getNowTime());
                teacherProjectAddBo.setUpdateTime(DateUtils.getNowTime());
                teacherProjectService.insertByAddBo(teacherProjectAddBo);
            }
        }
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(Teacher entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
